OpenJPH: ojph::ppm_out Class Reference

OpenJPH Open-source implementation of JPEG2000 Part-15

Loading...
Searching...
No Matches
ojph::ppm_out Class Reference

`#include <ojph_img_io.h>`

Inheritance diagram for ojph::ppm_out:

## Public Member Functions
| ppm_out ()
virtual | ~ppm_out ()
void | open (char *filename)
void | configure (ui32 width, ui32 height, ui32 num_components, ui32 bit_depth)
virtual ui32 | write (const line_buf *line, ui32 comp_num)
virtual void | close ()
Public Member Functions inherited from ojph::image_out_base
virtual | ~image_out_base ()

## Private Attributes
FILE * | fh
const char * | fname
ui32 | width
ui32 | height
ui32 | num_components
ui32 | bit_depth
ui32 | bytes_per_sample
ui8 * | buffer
size_t | buffer_size
ui32 | cur_line
ui32 | samples_per_line
ui32 | bytes_per_line
conversion_fun | converter
const line_buf * | lptr [3]

## Detailed Description

Definition at line 590 of file ojph_img_io.h.

## Constructor & Destructor Documentation

## ◆ ppm_out()

ojph::ppm_out::ppm_out | ( |  | ) |
| inline

Definition at line 593 of file ojph_img_io.h.

References bit_depth, buffer, buffer_size, bytes_per_line, bytes_per_sample, converter, cur_line, fh, fname, height, lptr, num_components, samples_per_line, and width.

## ◆ ~ppm_out()

virtual ojph::ppm_out::~ppm_out | ( |  | ) |
| inlinevirtual

Definition at line 605 of file ojph_img_io.h.

References buffer, and close().

## Member Function Documentation

## ◆ close()

virtual void ojph::ppm_out::close | ( |  | ) |
| inlinevirtual

Reimplemented from ojph::image_out_base.

Definition at line 616 of file ojph_img_io.h.

References fh, and fname.

Referenced by ~ppm_out().

## ◆ configure()

void ojph::ppm_out::configure | ( | ui32 | width,
|  | ui32 | height,
|  | ui32 | num_components,
|  | ui32 | bit_depth )

Definition at line 446 of file ojph_img_io.cpp.

References ojph::avx2_cvrt_32b1c_to_16ub1c_be(), ojph::avx2_cvrt_32b1c_to_8ub1c(), ojph::avx2_cvrt_32b3c_to_8ub3c(), bit_depth, bytes_per_line, bytes_per_sample, converter, fh, ojph::gen_cvrt_32b1c_to_16ub1c_be(), ojph::gen_cvrt_32b1c_to_8ub1c(), ojph::gen_cvrt_32b3c_to_16ub3c_be(), ojph::gen_cvrt_32b3c_to_8ub3c(), ojph::get_cpu_ext_level(), height, num_components, OJPH_ERROR, samples_per_line, ojph::sse41_cvrt_32b1c_to_16ub1c_be(), ojph::sse41_cvrt_32b1c_to_8ub1c(), ojph::sse41_cvrt_32b3c_to_16ub3c_be(), ojph::sse41_cvrt_32b3c_to_8ub3c(), width, ojph::X86_CPU_EXT_LEVEL_AVX2, and ojph::X86_CPU_EXT_LEVEL_SSE41.

Referenced by main().

## ◆ open()

void ojph::ppm_out::open | ( | char * | filename | ) |

Definition at line 386 of file ojph_img_io.cpp.

References bit_depth, buffer, buffer_size, bytes_per_sample, cur_line, fh, fname, height, num_components, OJPH_ERROR, OJPH_WARN, and width.

Referenced by main().

## ◆ write()

ui32 ojph::ppm_out::write | ( | const line_buf * | line,
|  | ui32 | comp_num )
| virtual

Implements ojph::image_out_base.

Definition at line 539 of file ojph_img_io.cpp.

References bit_depth, buffer, bytes_per_sample, converter, fh, fname, lptr, num_components, OJPH_ERROR, samples_per_line, and width.

## Member Data Documentation

## ◆ bit_depth

ui32 ojph::ppm_out::bit_depth
| private

Definition at line 622 of file ojph_img_io.h.

Referenced by configure(), open(), ppm_out(), and write().

## ◆ buffer

ui8* ojph::ppm_out::buffer
| private

Definition at line 623 of file ojph_img_io.h.

Referenced by open(), ppm_out(), write(), and ~ppm_out().

## ◆ buffer_size

size_t ojph::ppm_out::buffer_size
| private

Definition at line 624 of file ojph_img_io.h.

Referenced by open(), and ppm_out().

## ◆ bytes_per_line

ui32 ojph::ppm_out::bytes_per_line
| private

Definition at line 625 of file ojph_img_io.h.

Referenced by configure(), and ppm_out().

## ◆ bytes_per_sample

ui32 ojph::ppm_out::bytes_per_sample
| private

Definition at line 622 of file ojph_img_io.h.

Referenced by configure(), open(), ppm_out(), and write().

## ◆ converter

conversion_fun ojph::ppm_out::converter
| private

Definition at line 626 of file ojph_img_io.h.

Referenced by configure(), ppm_out(), and write().

## ◆ cur_line

ui32 ojph::ppm_out::cur_line
| private

Definition at line 625 of file ojph_img_io.h.

Referenced by open(), and ppm_out().

## ◆ fh

FILE* ojph::ppm_out::fh
| private

Definition at line 619 of file ojph_img_io.h.

Referenced by close(), configure(), open(), ppm_out(), and write().

## ◆ fname

const char* ojph::ppm_out::fname
| private

Definition at line 620 of file ojph_img_io.h.

Referenced by close(), open(), ppm_out(), and write().

## ◆ height

ui32 ojph::ppm_out::height
| private

Definition at line 621 of file ojph_img_io.h.

Referenced by configure(), open(), and ppm_out().

## ◆ lptr

const line_buf* ojph::ppm_out::lptr[3]
| private

Definition at line 627 of file ojph_img_io.h.

Referenced by ppm_out(), and write().

## ◆ num_components

ui32 ojph::ppm_out::num_components
| private

Definition at line 621 of file ojph_img_io.h.

Referenced by configure(), open(), ppm_out(), and write().

## ◆ samples_per_line

ui32 ojph::ppm_out::samples_per_line
| private

Definition at line 625 of file ojph_img_io.h.

Referenced by configure(), ppm_out(), and write().

## ◆ width

ui32 ojph::ppm_out::width
| private

Definition at line 621 of file ojph_img_io.h.

Referenced by configure(), open(), ppm_out(), and write().

The documentation for this class was generated from the following files:

- /build/openjph/src/OpenJPH/src/apps/common/ojph_img_io.h
- /build/openjph/src/OpenJPH/src/apps/others/ojph_img_io.cpp